/********************************************************************
*               MINI-COMPILADOR PARA O MINI-PASCAL                  *
* ----------------------------------------------------------------- *
*      Membros: Anderson de Rezende Rocha - DCC/UFLA                *
*               undersun@comp.ufla.br                              *
*                                                                   *
*               Jlio Csar Alves - DCC/UFLA                        *
*               jcalves@comp.ufla.br                                *
* ----------------------------------------------------------------- *
*          COMPILADORES: Prof. Mrio Luis R. Oliveira               *
********************************************************************/

/*
    OBSERVAES:
        + Identificador  forma utilizada para guardar qual o tipo de dado (inteiro, booleano, real ...)
         eh um identificador

    MTODOS:
        + clIdentificador(string umNome = "", FLAGS umTipo = NENHUMA);
        + ~clIdentificador();
        + string GetNome();
        + FLAGS GetTipo();
        + void SetNome(string umNome);
        + void SetTipo(FLAGS umTipo);
        + bool operator==(const clIdentificador& id);
        + void Imprimir();
*/


#ifndef IDENTIFICADOR_H
#define IDENTIFICADOR_H

using namespace std;

class clIdentificador
{
    public:
        // Construtor completo
        clIdentificador(string umNome = "", FLAGS umTipo = NENHUMA);
        // Destrutor
        ~clIdentificador();
        // Retorna o nome armazenado neste identificador
        string GetNome();
        // Retorna o tipo armazenado neste identificador
        FLAGS GetTipo();
        // Seta um novo nome para este identificador
        void SetNome(string umNome);
        // Seta um novo tipo para este identificador
        void SetTipo(FLAGS umTipo);
        // Compara dois identificadores quanto  igualdade
        bool operator==(const clIdentificador& id);
        // Imprime na sada padro o identificador
        void Imprimir();
    private:
        // Guarda o nome do identificador
        string nome;
        // Guarda o tipo do identificador
        FLAGS tipo;
};

// Construtor completo a partir de um tipo e de um nome
clIdentificador::clIdentificador(string umNome, FLAGS umTipo)
{
    SetNome(umNome);
    SetTipo(umTipo);
}

// Destrutor
clIdentificador::~clIdentificador(){}

// Retorna o nome armazenado neste identificador
string clIdentificador::GetNome()
{
    return nome;
}

// Retorna o tipo armazenado neste identificador
FLAGS clIdentificador::GetTipo()
{
    return tipo;
}

// Seta um novo nome para este identificador
void clIdentificador::SetNome(string umNome)
{
    nome = umNome;
}

// Seta um tipo para este identificador
void clIdentificador::SetTipo(FLAGS umTipo)
{
    tipo = umTipo;
}

// Compara dois identificadores quanto  igualdade
bool clIdentificador::operator==(const clIdentificador& id)
{
    return (nome == id.nome);
}

// Imprime na sada padro do sistema o estado interno deste
// identificador
void clIdentificador::Imprimir()
{
    cout << "Nome: " << GetNome() << ", Tipo: " << GetTipo() << endl;
}

#endif

