/********************************************************************
*               MINI-COMPILADOR PARA O MINI-PASCAL                  *
* ----------------------------------------------------------------- *
*      Membros: Anderson de Rezende Rocha - DCC/UFLA                *
*               undersun@comp.ufla.br                              *
*                                                                   *
*               Jlio Csar Alves - DCC/UFLA                        *
*               jcalves@comp.ufla.br                                *
* ----------------------------------------------------------------- *
*          COMPILADORES: Prof. Mrio Luis R. Oliveira               *
********************************************************************/

/*
    OBSERVAES:
        + Utilizada pelo compilador para fazer um LOG dos erros
          encontrados durante a anlise de um arquivo de entrada
        + Controla o nmero de erros encontrados modus que ao se
          atingir certo nmero o compilador possa interromper sua
          ao e reportar-se ao usurio

    MTODOS DISPONVEIS:
        + clLogErros()
        + ~clLogErros()
        + void Log(string token, int linha)
        + void Log(string mensagem)
        + void Append(string mensagem)
        + int GetNroErros();
        + void Fim();
*/


#ifndef LOG_ERROS_H
#define LOG_ERROS_H

#include<iostream>
#include<string>

using namespace std;

class clLogErros
{
    public:
        // Construtor padro
        clLogErros();
        // Destrutor
        ~clLogErros() {}
        // Imprimir o token passado e a linha do mesmo
        void Log(string token, int linha);
        // Imprime uma mensagem de erro passada
        void Log(string mensagem);
        // Serve para concatenar vrias mensagens em uma
        // Nao incrementa o numero de erros
        void Append(string mensagem);
        // Devolve o nmero de erros encontrados at o momento
        int GetNroErros();
        // Permite reportar ao usurio o trmino de cada fase do
        // compilador
        void Fim();

    private:
        // Armazena o nmero de erros
        int nroErros;
        // Armazena o nmero de erros lexicos
        int errosLexicos;
};

// Construtor padro
clLogErros::clLogErros()
{
    nroErros = 0;
    errosLexicos = -1;
}

// Imprime o token passado e a linha do mesmo
void clLogErros::Log(string token, int linha)
{
    if (nroErros == 0)
        cout << endl;
    if (errosLexicos == -1)
        cout << "\nERRO na linha " << linha << ": Token invalido encontrado: " << token;
    else
        cout << "\nERRO na linha " << linha << ", no token " << token;
    nroErros++;
}

// Imprime uma mensagem de erro passada
void clLogErros::Log(string mensagem)
{
    if (nroErros == 0)
        cout << endl;
    cout << "\nERRO: " << mensagem;
    nroErros++;
}

// Permite reportar ao usurio o trmino de cada fase do
// compilador
void clLogErros::Fim()
{   if (errosLexicos == -1)
    {
        errosLexicos = nroErros;
        if (errosLexicos == 0)
            cout << "\t0K" << endl;
    }
    else if (nroErros - errosLexicos == 0)
        cout << "\t0K" << endl;
}

// Devolve o nmero de erros encontrados at o momento
int clLogErros::GetNroErros()
{
    return nroErros;
}

// Serve para concatenar vrias mensagens em uma
// Nao incrementa o numero de erros
void clLogErros::Append(string mensagem)
{
    cout << " " << mensagem;
    nroErros++;
}

#endif

