/********************************************************************
*               MINI-COMPILADOR PARA O MINI-PASCAL                  *
* ----------------------------------------------------------------- *
*      Membros: Anderson de Rezende Rocha - DCC/UFLA                *
*               undersun@comp.ufla.br                              *
*                                                                   *
*               Jlio Csar Alves - DCC/UFLA                        *
*               jcalves@comp.ufla.br                                *
* ----------------------------------------------------------------- *
*          COMPILADORES: Prof. Mrio Luis R. Oliveira               *
********************************************************************/

/*
    OBSERVAES:
        + Utilizada pela lista para se conseguir uma lista dinmica
        + O operador '==' DEVE estar definido na classe 'TValor'.
    
    MTODOS
        + clNohLista();           
        + ~clNohLista();
        + clNohLista *Proximo();
        + TValor Valor();
        + TValor *ValorRef();
        + void CopiarValor(const TValor &v); 
        + void Proximo(clNohLista *noh);     
*/

#ifndef CLNOHLISTA_H
#define CLNOHLISTA_H

using namespace std;

// Template para se conseguir criar nohs de lista genricos
template <class TValor>
class clNohLista
{
    public:
        // Construtor padro
        clNohLista();           
        // Destrutor
        ~clNohLista();
        // Referncia para o prximo elemento da lista
        clNohLista *Proximo();
        // Retorna uma cpia do valor de um dado noh
        TValor Valor();
        // Retorna uma referncia do valor de um dado noh
        TValor *ValorRef();
        // Copia o valor 'v' para o noh atual
        void CopiarValor(const TValor &v); 
        // Seta o prximo noh do atual noh, montando, assim, a lista
        void Proximo(clNohLista *noh);     
    protected:
        // Referncia para o valor do noh
        TValor *valor;       
        // Referencia para o proximo noh da lista
        clNohLista *proximo;  
};

// Construtor padro
template <class TValor>
clNohLista<TValor>::clNohLista()
{
    valor = NULL;
    proximo = NULL;
}

// Destrutor
template <class TValor>
clNohLista<TValor>::~clNohLista()
{
    if (valor != NULL)
        delete valor;
}


// Retorna uma cpia do valor de um dado noh
template <class TValor>
TValor clNohLista<TValor>::Valor()
{
    return *valor;
}

// Retorna uma referncia do valor de um dado noh
template <class TValor>
TValor *clNohLista<TValor>::ValorRef()
{
    return valor;
}

// Referncia para o prximo elemento da lista
template <class TValor>
clNohLista<TValor>* clNohLista<TValor>::Proximo()
{
    return proximo;
}

template <class TValor>
void clNohLista<TValor>::Proximo(clNohLista *noh)
// muda o valor do proximo
{
    proximo = noh;
}

template <class TValor>
void clNohLista<TValor>::CopiarValor(const TValor &v)
// muda o valor do noh
{
     if (valor != NULL)
        delete valor;
    valor = new TValor(v);
}

#endif

